#include "StdAfx.h"
#include "Group.h"

CGroup::CGroup(void)
{
	countgroups=0;
	AddGroup(CString(L""));
}

CGroup::~CGroup(void)
{
}

int CGroup::AddGroup(CString& GroupName)
{
	int index=-1;
	for(int i=0;i<countgroups;i++)
	{
		if(GroupList.GetAt(i).GroupName == GroupName)
		{
			index = GroupList.GetAt(i).id;
			return index;
		}
	}
	
	if(GroupList.GetSize()<=countgroups)
			GroupList.SetSize(GroupList.GetSize()+5);
	Group newGr;
	newGr.GroupName = GroupName;
	newGr.id = countgroups;
	newGr.countusers = 1;
	GroupList[countgroups] = newGr;
		countgroups++;
	return newGr.id;
}

int CGroup::GetGroupNamebyId(int id, CString& GroupName)
{
	GroupName="";
	int index = GetIndexbyId(id);
	if(index==-1)
		return 0;
	GroupName = GroupList.GetAt(index).GroupName;
	return 1;
}

int CGroup::SetInBand(int id, float maxin)
{
	int index = GetIndexbyId(id);
		if(index==-1)
			return 0;
		GroupList[index].Group_InBandwidth = maxin;
		return 1;
}
int CGroup::SetOutBand(int id, float maxout)
{
	int index = GetIndexbyId(id);
		if(index==-1)
			return 0;
		GroupList[index].Group_OutBandwidth = maxout;
		return 1;
}
int CGroup::GetIndexbyId(int id)
{
	if(GroupList.GetCount()>id)
	if(GroupList.GetAt(id).id == id)
	{
		return id;
	}
	
	for(int i=0;i<countgroups;i++)
	{
		if(GroupList.GetAt(i).id == id)
		{
			return i;
		}
	}
	return -1;
}

float CGroup::GetInBand(int id)
{
	int index = GetIndexbyId(id);
		if(index==-1)
			return 0;
	return	GroupList[index].Group_InBandwidth;

}
float CGroup::GetOutBand(int id)
{
	int index = GetIndexbyId(id);
		if(index==-1)
			return 0;
	return	GroupList[index].Group_OutBandwidth;

}

int CGroup::GetIdbyName(CString& GroupName)
{
int index=-1;
	for(int i=0;i<countgroups;i++)
	{
		if(GroupList.GetAt(i).GroupName == GroupName)
		{
			index = GroupList.GetAt(i).id;
			return index;
		}
	}
	return -1;
}

int CGroup::AddActive(int id, float ktraff)
{
int index = GetIndexbyId(id);
	if(index==-1)
		return 0;
	GroupList[index].countact++;
	GroupList[index].ktraff+=ktraff;
	GroupList[index].ktraffOut = GroupList[index].ktraff;
	return GroupList[index].countact;

}

int CGroup::ResetAllActiveData(void)
{
	for(int i=0;i<countgroups;i++)
	{
		GroupList[i].countact=0;
		GroupList[i].countICQusers=0;
		GroupList[i].SleepersCount=0;
		GroupList[i].ktraff=0.0;
		GroupList[i].ChanalForAct=GroupList[i].Group_InBandwidth;

	}
	return 0;
}

int CGroup::GetActiveCount(int id)
{
	int index = GetIndexbyId(id);
	if(index==-1)
		return 0;
	return GroupList.GetAt(index).countact;
}

int CGroup::AddICQAct(int id)
{
	int index = GetIndexbyId(id);
	if(index==-1)
		return 0;
	GroupList[index].countICQusers++;
	return GroupList[index].countICQusers;
	
}

int CGroup::AddSleeper(int id)
{
	int index = GetIndexbyId(id);
	if(index==-1)
		return 0;
	GroupList[index].SleepersCount++;
	return GroupList[index].SleepersCount;

}

int CGroup::GetCountAct(int& act,int& sleep, int& icq)
{
	act=0;
	sleep=0;
	icq=0;
	for(int i=0;i<countgroups;i++)
	{
		act+=GroupList[i].countact;
		sleep+=GroupList[i].SleepersCount;
		icq+=GroupList[i].countICQusers;
	}
	return act;
}

int CGroup::DeleteGr(int id)
{
	int index = GetIndexbyId(id);
	GroupList.RemoveAt(index);
	countgroups--;
	for(int i=index;i<GroupList.GetCount();i++)
	{
		GroupList[i].id--;
	}
	return 0;
}
