// GroupsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "tispd.h"
#include "tispdDlg.h"
#include "GroupsDlg.h"


// CGroupsDlg dialog

IMPLEMENT_DYNAMIC(CGroupsDlg, CDialog)

CGroupsDlg::CGroupsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGroupsDlg::IDD, pParent)
{
	grchanalin=0,5;
}

CGroupsDlg::~CGroupsDlg()
{
}

void CGroupsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_GROUPS, ListGroups);
	DDX_Text(pDX, IDC_EDIT_CHANALIN, grchanalin);
	DDX_Text(pDX, IDC_EDIT_GRNAME, grName);
	DDX_Control(pDX, IDC_LIST_GROUPSNONEUSERS, ListUsersNoGr);
	DDX_Control(pDX, IDC_LIST_GROUPSUSERS, ListUsersInGr);
}


BEGIN_MESSAGE_MAP(CGroupsDlg, CDialog)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_BUTTON_CHANGEGR, &CGroupsDlg::OnBnClickedButtonChangegr)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_GROUPS, &CGroupsDlg::OnLvnItemchangedListGroups)
	ON_BN_CLICKED(IDC_BUTTON_ADDUSERTOGROUP, &CGroupsDlg::OnBnClickedButtonAddusertogroup)
	ON_BN_CLICKED(IDC_BUTTON_ADDUSERTOGROUP2, &CGroupsDlg::OnBnClickedButtonAddusertogroup2)
	ON_BN_CLICKED(IDC_BUTTON_DELGR, &CGroupsDlg::OnBnClickedButtonDelgr)
	ON_BN_CLICKED(IDC_BUTTON_GETGRFROMTI, &CGroupsDlg::OnBnClickedButtonGetgrfromti)
END_MESSAGE_MAP()


// CGroupsDlg message handlers

BOOL CGroupsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	InitList();
	ShowGroups();
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

int CGroupsDlg::ShowGroups(void)
{
	CtispdDlg* pDlg = (CtispdDlg*)pTIDlg;
	CGroup *pGr = &pDlg->Groups;
	CListCtrl* pmyListCtrl = &ListGroups;
	int index;
	CString str;
	pmyListCtrl->DeleteAllItems();
	float ktr=0.0;
	float sumk=0.0;
	for(int i=pGr->countgroups-1;i > 0;i--)
	{
		sumk+=pGr->GroupList[i].Group_InBandwidth;
		str.Format(L"%d",pGr->GroupList[i].id);
		index = pmyListCtrl->InsertItem(LVIF_TEXT|LVIF_STATE, 0 ,str , 
						0, LVIS_SELECTED, 0, 0);
		pmyListCtrl->SetItemData(index, i);
		
		pmyListCtrl->SetItemText(index,GR_NAME ,pGr->GroupList[i].GroupName);


		str.Format(L"%0.2f",pGr->GroupList[i].Group_InBandwidth*100);
		CString str2;
		str2.Format(L"%0.1f ",(double)pGr->GroupList[i].Group_InBandwidth*pDlg->SDlg.dmaxin/pDlg->kbytes);
		str=str+L"% ("+str2+pDlg->speedval+L" max)";
		pmyListCtrl->SetItemText(index,GR_MAXIN ,str);
		str.Format(L"%d",pGr->GroupList[i].countusers);
		pmyListCtrl->SetItemText(index,GR_CUSERS ,str);
		 ktr=0.0;
		for(int j=0;j<pDlg->maxuserscount;j++)
		{
			if(pDlg->Users[j].groupid==pGr->GroupList[i].id)
			{
				ktr+=pDlg->Users[j].ktraff;
			}
		}
		str.Format(L"%.2f",ktr);
		pmyListCtrl->SetItemText(index,GR_SUMK ,str);


	}
	str.Format(L"%.2f  1.0   . : %.2f",sumk,1.0-sumk);
	GetDlgItem(IDC_STATIC_SUMCHANAL)->SetWindowTextW(str);
	ShowGroupDetails();
	return 0;
}

void CGroupsDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	CString str;
	CtispdDlg *pDlg = (CtispdDlg *)pTIDlg;
	str.Format(L".   : %0.1f ",pDlg->SDlg.dmaxin/pDlg->kbytes);
	str=str+pDlg->speedval;
	GetDlgItem(IDC_STATIC_CHANALIN)->SetWindowTextW(str);

	// Do not call CDialog::OnPaint() for painting messages
}

void CGroupsDlg::OnBnClickedButtonChangegr()
{
		CListCtrl* pmyListCtrl=&ListGroups;	
		CtispdDlg *pDlg = (CtispdDlg *)pTIDlg;
	/*POSITION pos = pmyListCtrl->GetFirstSelectedItemPosition();
if (pos != NULL)
{
//   while (pos)
   {
      int nItem =  pmyListCtrl->GetNextSelectedItem(pos);
      CString GrName;
	   GrName = pmyListCtrl->GetItemText(nItem,1);
	   */
		UpdateData(TRUE);
		if(grName.IsEmpty())
		   return;
	   int id = pDlg->Groups.GetIdbyName(grName);
	   if(id!=-1)
	   {
		   pDlg->Groups.SetInBand(id,grchanalin);
	   }
	   else
	   {
		   id = pDlg->Groups.AddGroup(grName);
		   pDlg->Groups.SetInBand(id,grchanalin);
	   }

	   ShowGroups();
	}

void CGroupsDlg::OnLvnItemchangedListGroups(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	CListCtrl * pmyListCtrl = &ListGroups;
	POSITION pos = pmyListCtrl->GetFirstSelectedItemPosition();
if (pos != NULL)
{
     int nItem =  pmyListCtrl->GetNextSelectedItem(pos);
    grName = pmyListCtrl->GetItemText(nItem,1);
	CtispdDlg *pDlg = (CtispdDlg *)pTIDlg;
	int id = pDlg->Groups.GetIdbyName(grName);
	if(id!=-1)
		grchanalin = pDlg->Groups.GetInBand(id);
	UpdateData(FALSE);
	ShowGroupDetails();
}
	*pResult = 0;
}

void CGroupsDlg::OnBnClickedButtonAddusertogroup()
{
	CListCtrl * pmyListCtrl = &ListUsersNoGr;
	CtispdDlg* pDlg = (CtispdDlg*)pTIDlg;
	POSITION pos = pmyListCtrl->GetFirstSelectedItemPosition();
if (pos != NULL)
{
	int id = pDlg->Groups.GetIdbyName(grName);
	if(id>0){
     int nItem =  pmyListCtrl->GetNextSelectedItem(pos);
    CString UsName = pmyListCtrl->GetItemText(nItem,0);
	for(int i=0;i<pDlg->maxuserscount;i++)
	{
		if(UsName==pDlg->Users[i].UserName_0)
		{
			pDlg->Users[i].groupid = id;
		}
	}
	pDlg->CalcUsCountInGr();
	ShowGroups();
	}
	
}
}

int CGroupsDlg::ShowGroupDetails(void)
{
	CtispdDlg* pDlg = (CtispdDlg*)pTIDlg;
	CGroup *pGr = &pDlg->Groups;
	CListCtrl* pmyListCtrl = &ListUsersInGr;
	pmyListCtrl->DeleteAllItems();
	int id = pGr->GetIdbyName(grName);
	CString str;
	if((id!=-1)&&(id!=0)){
		
	for(int i=pDlg->maxuserscount-1;i >= 0;i--)
	{
		if(pDlg->Users[i].groupid==id)
		{
		
		int index = pmyListCtrl->InsertItem(LVIF_TEXT|LVIF_STATE, 0 ,pDlg->Users[i].UserName_0 , 
						0, LVIS_SELECTED, 0, 0);
		pmyListCtrl->SetItemData(index, i);
			str.Format(L"%.2f",pDlg->Users[i].ktraff);
		pmyListCtrl->SetItemText(index,1 ,str);
		}
		
	}
	}

	pmyListCtrl = &ListUsersNoGr;
	pmyListCtrl->DeleteAllItems();
	
	for(int i=pDlg->maxuserscount-1;i >= 0;i--)
	{
		if(pDlg->Users[i].groupid==0)
		{
		int index = pmyListCtrl->InsertItem(LVIF_TEXT|LVIF_STATE, 0 ,pDlg->Users[i].UserName_0 , 
						0, LVIS_SELECTED, 0, 0);
		pmyListCtrl->SetItemData(index, i);
				str.Format(L"%.2f",pDlg->Users[i].ktraff);
		pmyListCtrl->SetItemText(index,1 ,str);
		}
		
	}

	return 0;
}

void CGroupsDlg::OnBnClickedButtonAddusertogroup2()
{
		CListCtrl * pmyListCtrl = &ListUsersInGr;
	CtispdDlg* pDlg = (CtispdDlg*)pTIDlg;
	POSITION pos = pmyListCtrl->GetFirstSelectedItemPosition();
if (pos != NULL)
{
	
	
     int nItem =  pmyListCtrl->GetNextSelectedItem(pos);
    CString UsName = pmyListCtrl->GetItemText(nItem,0);
	for(int i=0;i<pDlg->maxuserscount;i++)
	{
		if(UsName==pDlg->Users[i].UserName_0)
		{
			pDlg->Users[i].groupid = 0;
		}
	}
	pDlg->CalcUsCountInGr();
	ShowGroups();
	
	
}
}

void CGroupsDlg::OnBnClickedButtonDelgr()
{
	
	CtispdDlg* pDlg = (CtispdDlg*)pTIDlg;
	
	int id = pDlg->Groups.GetIdbyName(grName);
	if(id>0)
	{	
	for(int i=0;i<pDlg->maxuserscount;i++)
	{
		if(pDlg->Users[i].groupid==id)
			pDlg->Users[i].groupid=0;
		if(pDlg->Users[i].groupid>id)
			pDlg->Users[i].groupid--;
	}
		pDlg->Groups.DeleteGr(id);
	ShowGroups();
	}
}

void CGroupsDlg::OnBnClickedButtonGetgrfromti()
{
	CtispdDlg* pDlg = (CtispdDlg*)pTIDlg;
	pDlg->OnBnClickedButtonGetgroupsfromti();
	ShowGroups();
}
